#pragma once

#include "Vec2.h"

template<class T>
class _Vec3
{
public:
	_Vec3() = default;
	_Vec3( const T X, const T Y, const T Z )
		:
		x( X ), y( Y ), z( Z )
	{
	}
	_Vec3( const _Vec2<T> &Src )
		:
		x( Src.x ),
		y( Src.y ),
		z( T(1) )
	{
	}

	T DotProduct( const _Vec3 &Rhs )const
	{
		return ( x * Rhs.x ) + ( y * Rhs.y ) + ( z * Rhs.z );
	}
public:
	T x, y, z;
};

using Vec3 = _Vec3<float>;